!c Description:
!c   Ǯη׻ץ
!c
!c Current Code Owner: 
!c   sugiyama@gfd-dennou.org
!c
!c Histry: 
!c   Version    Date          Comment
!c   -------    ----------    --------
!c   1.0        2003-03-31    
!c
!c Copyright (C) SUGIYAMA Ko-ichiro, 2003, All rights reserved


program obradbt
  use gtool_history
  use prm_common, only: obrinit, struct, property, emol_ini, &
       & smax, emax, step, pres_ini, pres_end, temp_ini, cnv, pseudosw 
  use interface_mingibbs
  use interface_mingibbs_chk
  use interface_entropy
  use interface_mol2emol
  use interface_rmcnd
  use interface_molfraction
  use interface_exec_time
  
  implicit none
  real(8), parameter          :: temp_chg = -0.5d0
  real(8), allocatable        :: pres_map(:)
  real(8), allocatable        :: entr_map(:)
  real(8), allocatable        :: temp_map(:)
  real(8), allocatable        :: emol_map(:,:)
  real(8), allocatable        :: mol_map(:,:)
  real(8), allocatable        :: molfr_map(:,:)
  real(8), allocatable        :: mol(:)
  real(8), allocatable        :: molfr(:)
  real(8), allocatable        :: emol(:)
  real(8)                     :: entr1
  real(8)                     :: entr2
  real(8)                     :: entr3
  real(8)                     :: entr_gas
  real(8)                     :: temp1
  real(8)                     :: temp2
  real(8)                     :: temp3
  real(8)                     :: n
  integer                  :: i, l
  integer                  :: time1(8)
  integer                  :: time2(8)
  integer                  :: time(2)
  logical                  :: esw
  
!!!
!!!¹Գϻ֤¬
!!!
  call date_and_time(values = time1)


!!!
!!!ǡƤӽФ
!!!
  call obrinit


!!!
!!!γ
!!!
  allocate(pres_map(step), &
       & entr_map(step), &
       & temp_map(step), &
       & mol_map(step, smax), &
       & molfr_map(step, smax), &
       & emol_map(step, emax), &
       & mol(smax))

!!!
!!!NetCDF եѰ
!!!
  call output_gtool4_init


!!!
!!!׻Ѥ밵Ϥ
!!!
  esw = .false.
  pres_map = pres_ini
  n = real(step-1, 8)
  do i = 2, step     
!     pres_map(i) = pres_ini &
!          & * 10.0d0**((i - 1) * dlog10(pres_end / pres_ini) / (step - 1))
     pres_map(i) = pres_ini + (i - 1) * (pres_end - pres_ini) / n
  end do
  call HistoryPut('p', real(pres_map, 4))


!!!
!!!, Ϥӷ׻
!!!
  l = 1
  temp2 = temp_ini
  call mingibbs_chk(temp2, pres_map(l), emol_ini, struct, property, mol)
  call entropy(temp2, pres_map(l), mol, &
       & property, entr_all=entr2, entr_gas=entr_gas)
  call store_data(l, esw)
  
  

!!!
!!!٤Ѳʤ׻
!!!
  CHANGE_PRES: do l = 2, step
!     write(*,*) "START CHANGE_PRES"
     
     !ΰϤǤμ«٤ǤΥȥԡӷ׻
     temp1 = temp_map(l - 1) + 2.0d0
     call mingibbs_chk(temp1, pres_map(l), &
          & emol_map(l-1,:), struct, property, mol, mol_map(l-1,:))
     call entropy(temp1, pres_map(l), mol, property, entr_all = entr1)

     !ǰΤΥå
     if (entr1 < entr_map(l-1)) then
        write(*,*) "the entropy is lower than the pervious entropy"
        write(*,*) "temp ", temp1
        write(*,*) "entr ", entr1, entr_map(l-1)
        stop
     end if

     !ƥå1: ȥԡͤ򶴤ಹ٤
     i = 1
     STEP1: do 
        !
        temp3 = temp1 + i * temp_chg
        
        !ȥԡη׻
        call mingibbs_chk(temp3, pres_map(l), &
             & emol_map(l-1,:), struct, property, mol, mol_map(l-1,:))
        call entropy(temp3, pres_map(l), mol, property, entr_all = entr3)

        !롼׽λ
        if (entr3 < entr_map(l-1)) exit STEP1
        
        !롼פ֤
        i = i + 1
        entr1 = entr3
        temp1 = temp3
     end do STEP1
     
     !ƥå 2: ٤ǤΥȥԡ, 1 ƥåǤ
     !            ȥԡƱˤʤޤǼ«.
     STEP2: do 
        !Ǥͤ׻
        temp2 = (temp1 + temp3) / 2.0d0
        
        call mingibbs_chk(temp2, pres_map(l), &
             & emol_map(l-1,:), struct, property, mol, mol_map(l-1,:))
        call entropy(temp2, pres_map(l), &
             & mol, property, entr_all=entr2, entr_gas=entr_gas)
        
        !롼׽λ. 
        if (abs((entr2 - entr_map(l-1))/entr_map(l-1)) <= cnv) then
           temp_map(l)   = temp2
           call store_data(l, esw)
           write(*,*) "(", l, ") ", "Entropy is now converged" 
           exit STEP2
        end if
        
        !Ū˲٤ˤϥå. 
        if (temp1 == temp2 .OR. temp2 == temp3) then
           write(*,*) "Conserved Entropy is slightly changed", &
                & entr_map(l-1), " -> ", entr2

!           ! temp3 Ƿ׻ʤ
!           call mingibbs_chk(temp3, pres_map(l), &
!                & emol_map(l-1,:), struct, property, mol, mol_map(l-1,:))
!           call entropy(temp3, pres_map(l), &
!                & mol, property, entr_all=entr2, entr_gas=entr_gas)           

           esw = .true. 
           call store_data(l, esw)
           esw = .false.

           write(*,*) "(", l, ") ", "Entropy is now converged" 
           exit STEP2
        end if
        
        !ƥåפʤ뤿ν
        if (entr3 < entr_map(l-1) .and. entr_map(l-1) < entr2) then
           temp1 = temp2
           entr1 = entr2
        elseif (entr2 <= entr_map(l-1) .and. entr_map(l-1) < entr1) then
           temp3 = temp2
           entr3 = entr2
        end if
     end do STEP2
  end do CHANGE_PRES


!!!
!!!NetCDF եĤ
!!!
  call HistoryClose


!!!
!!!¹Գϻ֤¬
!!!
  call date_and_time(values = time2)
  call exec_time(time1, time2, time)
  write(*,*) "׻¹Ի: ", time(1), "ʬ", time(2), ""

contains

  subroutine output_gtool4_init
    use prm_common, only: smax, emax, planet, AdbtFile 
    use gtool_history
    
    implicit none
    real(8)                 :: spc(smax)
    real(8)                 :: elm(emax)
    integer              :: num  
    integer              :: i 
    character(1000)         :: dataset
    
    
    !ե˽񤭽Ф٤ͤѿ
    write(dataset, *) "pseudosw= ", pseudosw, "  ", &
         & planet, property%name
    num = len_trim(dataset)

    !°, ɸ
    call HistoryCreate(&
         & file=AdbtFile, &
         & title="Equilibrium Calculation", &
         & source=dataset(:num+1), &
         & institution="GFD_Dennou_Club OBORO Project", &
         & dims=(/'spc ', 'elm ', 'pres'/), &
         & dimsizes=(/int(smax, 4), int(emax, 4), 0/), &
         & longnames=(/"chemical species", "element         ", "Pressure        "/), &
         & units=(/"1 ", "1 ", "Pa"/), &
         & origin=0.0,  &
         & interval=0.0)
    
    !
    spc = (/(i, i = 1, smax)/)
    call HistoryPut('spc', real(spc, 4))
    elm = (/(i, i = 1, emax)/)
    call HistoryPut('elm', real(elm, 4))
    
    !ѿ, ȥԡ
    call HistoryAddVariable( &
         & varname="entr", &
         & dims=(/'pres'/), &
         & longname="Entropy", &
         & units='J', &
         & xtype="double" )
    
    !ѿ, 
    call HistoryAddVariable( &
         & varname="temp", &
         & dims=(/'pres'/), &
         & longname="Temperature", &
         & units='K', &
         & xtype="double" )
    
    !ѿ, 
    call HistoryAddVariable( &
         & varname="mol", &           
         & dims=(/'spc ', 'pres'/), &
         & longname="Chemical Species Abundance", &
         & units='mol', &
         & xtype="double" )

    !ѿ, 
    call HistoryAddVariable( &
         & varname="molfr", &           
         & dims=(/'spc ', 'pres'/), &
         & longname="Mol Fraction", &
         & units='1', &
         & xtype="double" )

    !ѿ, 
    call HistoryAddVariable( &
         & varname="emol", &           
         & dims=(/'elm ', 'pres'/), &
         & longname="Element Abundance", &
         & units='mol', &
         & xtype="double" )

  end subroutine output_gtool4_init


  subroutine store_data(l, sw)
    use prm_common, only: ErrCode
    implicit none
    integer           :: l
    logical           :: sw

    temp_map(l) = temp2
    mol_map(l, :) = mol
    call molfraction(mol, property%phase, molfr)
    molfr_map(l,:) = molfr(:)
    if (pseudosw) then 
       entr_map(l)   = entr_gas
       call rmcnd(mol, property)
       call mol2emol(mol, struct, emol)
       emol_map(l, :) = emol(:)
    else
       entr_map(l)   = entr2
       emol_map(l, :) = emol_ini   !̤¸
    end if

    ! ȥԡ«ʤν. »ͤȤư
    if (sw) then 
       entr_map(l)    = entr_map(l-1)
       emol_map(l,:) = emol_ini
    end if
       
    call HistoryPut('pres', pres_map(l))
    call HistoryPut('temp', temp_map(l))
    call HistoryPut('mol', mol_map(l,:))
    call HistoryPut('molfr', molfr_map(l,:))
    call HistoryPut('entr', entr_map(l))
    call HistoryPut('emol', emol_map(l,:))
    
  end subroutine store_data
  
  
end program obradbt
